zoukankan      html  css  js  c++  java
  • Split Shape by Plane in OpenCASCADE

    Split Shape by Plane in OpenCASCADE

    eryar@163.com

    Abstract. Sometimes you want to split a shape by plane or even split a shape by a B Spline surface, OpenCASCADE provide a feature class BRepFeat_SplitShape to implement the function. The paper give a sample code to split a cylinder by plane.

    Key Words. Split Shape, BRep Feature Algorithms.

    1. Introduction

    OpenCASCADE提供了Boolean Operation实现了任意两个形状的交、并、差的布尔操作。但是如何实现用一个面将一个形状切割成两半呢?其实Boolean Operation中已经有求交分割的算法,但是没有直接提供一个分割的功能类,而是在BRepFeat_SplitShape提供了分割功能。

    wps69BE.tmp

    Figure 1. Split Cylinder by Plane

    2. Code Demo

    使用类BRepAlgoAPI_Section和类BRepFeat_SplitShape相结合来实现分割Split形状的功能。完整代码示例如下:

    /*
    Copyright(C) 2017 Shing Liu(eryar@163.com)

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files(the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions :

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
    */

    // Visual Studio 2013 & OpenCASCADE7.1.0

    #include <gp_Pln.hxx>

    #include <TopoDS.hxx>

    #include <TopExp.hxx>
    #include <TopExp_Explorer.hxx>

    #include <BRepTools.hxx>

    #include <BRepPrimAPI_MakeCylinder.hxx>

    #include <BRepAlgoAPI_Section.hxx>

    #include <BRepFeat_SplitShape.hxx>

    #pragma comment(lib, "TKernel.lib")
    #pragma comment(lib, "TKMath.lib")

    #pragma comment(lib, "TKG2d.lib")
    #pragma comment(lib, "TKG3d.lib")
    #pragma comment(lib, "TKGeomBase.lib")
    #pragma comment(lib, "TKGeomAlgo.lib")

    #pragma comment(lib, "TKBRep.lib")
    #pragma comment(lib, "TKTopAlgo.lib")

    #pragma comment(lib, "TKBO.lib")
    #pragma comment(lib, "TKPrim.lib")
    #pragma comment(lib, "TKFeat.lib")

    //! Test split a cylinder by plane.
    //! You can use the algorithm to split other shapes.
    void testSplit()
    {
        BRepPrimAPI_MakeCylinder aCylinderMaker(10.0, 20.0);
        TopoDS_Shape aCylinder = aCylinderMaker.Shape();

        // Build section by the split plane for the cylinder.
        BRepAlgoAPI_Section aSection(aCylinder, gp_Pln(gp_Pnt(0.0, 0.0, 15.0), gp::DZ()), Standard_False);
        aSection.ComputePCurveOn1(Standard_True);
        aSection.Approximation(Standard_True);
        aSection.Build();

        // Split the cylinder shape.
        BRepFeat_SplitShape aShapeSpliter(aCylinder);

        for (TopExp_Explorer i(aSection.Shape(), TopAbs_EDGE); i.More(); i.Next())
        {
            TopoDS_Shape anEdge = i.Current();
            TopoDS_Shape aFace;

            if (aSection.HasAncestorFaceOn1(anEdge, aFace))
            {
                TopoDS_Edge E = TopoDS::Edge(anEdge);
                TopoDS_Face F = TopoDS::Face(aFace);

                aShapeSpliter.Add(E, F);
            }
        }

        aShapeSpliter.Build();

        // Rebuild left and right shape.
        BRep_Builder aBuilder;
        TopoDS_Compound aLeftCompound;
        TopoDS_Compound aRightCompound;

        aBuilder.MakeCompound(aLeftCompound);
        aBuilder.MakeCompound(aRightCompound);

        // Left shape.
        TopTools_MapOfShape aLeftShapeMap;
        const TopTools_ListOfShape& aLeftShapes = aShapeSpliter.Left();
        for (auto i = aLeftShapes.cbegin(); i != aLeftShapes.cend(); i++)
        {
            aLeftShapeMap.Add(*i);

            aBuilder.Add(aLeftCompound, *i);
        }

        // Right shape.
        TopTools_IndexedMapOfShape aShapeMap;
        TopExp::MapShapes(aShapeSpliter.Shape(), TopAbs_FACE, aShapeMap);

        for (auto i = aShapeMap.cbegin(); i != aShapeMap.cend(); i++)
        {
            if (!aLeftShapeMap.Contains(*i))
            {
                aBuilder.Add(aRightCompound, *i);
            }
        }

        // Output left and right shape.
        BRepTools::Write(aLeftCompound, "d:/left.brep");
        BRepTools::Write(aRightCompound, "d:/right.brep");
    }

    int main(int argc, char* argv[])
    {
        testSplit();

        return 0;
    }

    先创建一个圆柱体,再使用类BRepAlgoAPI_Section将圆柱体用平面进行分割,最后使用类BRepFeat_SplitShape进行分类,得到切割后的形状及Left()形状,把切割后形状中的Left过滤后剩下就是切割另一半的形状;最后导出被平面切割后得到的两半形状。结果用动画演示如下:

    split shape

    Figure 2. Split Shape animation demo

    3. Conclusion

    OpenCASCADE提供类BRepFeat_SplitShape来实现对一个形状进行切割的功能,但是要配合BRepAlgoAPI_Section使用。因为Boolean Operation中已经实现了求交、分类的功能,所以在最新版本的源码7.2.0中已经将分割功能集成到了Boolean Operation中。分割后如果没有被改变的面还是原来的面。

  • 相关阅读:
    bzoj1432_[ZJOI2009]Function
    Luogu1681_ 最大正方形II
    初等数论-Base-2(扩展欧几里得算法,同余,线性同余方程,(附:裴蜀定理的证明))
    [bzoj2456] mode
    初等数论-Base-1(筛法求素数,欧拉函数,欧几里得算法)
    小程序之Tab切换
    vue-axios基本用法
    vue-过渡动画
    vue-router实例
    永恒之蓝漏洞利用复现
  • 原文地址:https://www.cnblogs.com/opencascade/p/SplitShape.html
Copyright © 2011-2022 走看看